#include<iostream>
#include<vector>
#define endl '\n'
using namespace std;
int n,res[100005],q,root;
vector<int> v[100005];
bool b[100005];
int dfs(int vr)
{
   int r=0;
   for(int i=0;i<v[vr].size();i++)
   {
       r+=dfs(v[vr][i]);
   }
   res[vr]=r;
   return r+1;
}
int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n;

    int u,t;
    for(int i=1;i<n;i++)
    {
        cin>>u>>t;
        b[t]=1;
        v[u].push_back(t);
    }
    for(int i=1;i<=n;i++)
    {
        if(!b[i]) {root=i;break;}
    }
    dfs(root);

    cin>>q;

    while(q--)
    {
        cin>>u;
        cout<<res[u]<<endl;
    }


}




